/* DeviceRow.c generated by valac 0.47.92, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#define BLUETOOTH_TYPE_DEVICE_ROW (bluetooth_device_row_get_type ())
#define BLUETOOTH_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow))
#define BLUETOOTH_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))
#define BLUETOOTH_IS_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_IS_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_DEVICE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))

typedef struct _BluetoothDeviceRow BluetoothDeviceRow;
typedef struct _BluetoothDeviceRowClass BluetoothDeviceRowClass;
typedef struct _BluetoothDeviceRowPrivate BluetoothDeviceRowPrivate;

#define BLUETOOTH_SERVICES_TYPE_DEVICE (bluetooth_services_device_get_type ())
#define BLUETOOTH_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice))
#define BLUETOOTH_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE))
#define BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDeviceIface))

typedef struct _BluetoothServicesDevice BluetoothServicesDevice;
typedef struct _BluetoothServicesDeviceIface BluetoothServicesDeviceIface;

#define BLUETOOTH_SERVICES_TYPE_DEVICE_PROXY (bluetooth_services_device_proxy_get_type ())

#define BLUETOOTH_SERVICES_TYPE_ADAPTER (bluetooth_services_adapter_get_type ())
#define BLUETOOTH_SERVICES_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter))
#define BLUETOOTH_SERVICES_IS_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER))
#define BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapterIface))

typedef struct _BluetoothServicesAdapter BluetoothServicesAdapter;
typedef struct _BluetoothServicesAdapterIface BluetoothServicesAdapterIface;

#define BLUETOOTH_SERVICES_TYPE_ADAPTER_PROXY (bluetooth_services_adapter_proxy_get_type ())
enum  {
	BLUETOOTH_DEVICE_ROW_0_PROPERTY,
	BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY,
	BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY,
	BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES];
typedef enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED,
	BLUETOOTH_DEVICE_ROW_STATUS_PAIRING,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT
} BluetoothDeviceRowStatus;

#define BLUETOOTH_DEVICE_ROW_TYPE_STATUS (bluetooth_device_row_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothDeviceRowButtonClickedData BluetoothDeviceRowButtonClickedData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL,
	BLUETOOTH_DEVICE_ROW_NUM_SIGNALS
};
static guint bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_NUM_SIGNALS] = {0};

struct _BluetoothDeviceRow {
	GtkListBoxRow parent_instance;
	BluetoothDeviceRowPrivate * priv;
};

struct _BluetoothDeviceRowClass {
	GtkListBoxRowClass parent_class;
};

struct _BluetoothServicesDeviceIface {
	GTypeInterface parent_iface;
	void (*cancel_pairing) (BluetoothServicesDevice* self, GError** error);
	void (*connect) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*connect_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	void (*connect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*disconnect) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*disconnect_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	void (*disconnect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*pair) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*pair_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesDevice* self, gint* result_length1);
	gboolean (*get_blocked) (BluetoothServicesDevice* self);
	void (*set_blocked) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_connected) (BluetoothServicesDevice* self);
	gboolean (*get_legacy_pairing) (BluetoothServicesDevice* self);
	gboolean (*get_paired) (BluetoothServicesDevice* self);
	gboolean (*get_trusted) (BluetoothServicesDevice* self);
	void (*set_trusted) (BluetoothServicesDevice* self, gboolean value);
	gint16 (*get_RSSI) (BluetoothServicesDevice* self);
	char* (*get_adapter) (BluetoothServicesDevice* self);
	gchar* (*get_address) (BluetoothServicesDevice* self);
	gchar* (*get_alias) (BluetoothServicesDevice* self);
	void (*set_alias) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_icon) (BluetoothServicesDevice* self);
	gchar* (*get_modalias) (BluetoothServicesDevice* self);
	gchar* (*get_name) (BluetoothServicesDevice* self);
	guint16 (*get_appearance) (BluetoothServicesDevice* self);
	guint32 (*get_class) (BluetoothServicesDevice* self);
};

struct _BluetoothServicesAdapterIface {
	GTypeInterface parent_iface;
	void (*remove_device) (BluetoothServicesAdapter* self, const char* device, GError** error);
	void (*set_discovery_filter) (BluetoothServicesAdapter* self, GHashTable* properties, GError** error);
	void (*start_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*start_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	void (*stop_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*stop_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesAdapter* self, gint* result_length1);
	gboolean (*get_discoverable) (BluetoothServicesAdapter* self);
	void (*set_discoverable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_discovering) (BluetoothServicesAdapter* self);
	gboolean (*get_pairable) (BluetoothServicesAdapter* self);
	void (*set_pairable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_powered) (BluetoothServicesAdapter* self);
	void (*set_powered) (BluetoothServicesAdapter* self, gboolean value);
	gchar* (*get_address) (BluetoothServicesAdapter* self);
	gchar* (*get_alias) (BluetoothServicesAdapter* self);
	void (*set_alias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesAdapter* self);
	gchar* (*get_name) (BluetoothServicesAdapter* self);
	guint (*get_class) (BluetoothServicesAdapter* self);
	guint (*get_discoverable_timeout) (BluetoothServicesAdapter* self);
	guint (*get_pairable_timeout) (BluetoothServicesAdapter* self);
};

struct _BluetoothDeviceRowPrivate {
	BluetoothServicesDevice* _device;
	BluetoothServicesAdapter* _adapter;
	GtkButton* connect_button;
	GtkImage* state;
	GtkLabel* state_label;
	GtkLinkButton* settings_button;
};

struct _BluetoothDeviceRowButtonClickedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothDeviceRow* self;
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	BluetoothServicesDevice* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	BluetoothServicesDevice* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	BluetoothServicesDevice* _tmp9_;
	GError* _vala1_e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	BluetoothServicesDevice* _tmp12_;
	GError* _vala2_e;
	GtkImage* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	BluetoothDeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};

static gint BluetoothDeviceRow_private_offset;
static gpointer bluetooth_device_row_parent_class = NULL;
static GtkSizeGroup* bluetooth_device_row_size_group;
static GtkSizeGroup* bluetooth_device_row_size_group = NULL;

GType bluetooth_device_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BluetoothDeviceRow, g_object_unref)
GType bluetooth_services_device_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_device_register_object (void* object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error);
GType bluetooth_services_device_get_type (void) G_GNUC_CONST;
GType bluetooth_services_adapter_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_adapter_register_object (void* object,
                                                  GDBusConnection* connection,
                                                  const gchar* path,
                                                  GError** error);
GType bluetooth_services_adapter_get_type (void) G_GNUC_CONST;
static GType bluetooth_device_row_status_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self);
BluetoothDeviceRow* bluetooth_device_row_new (BluetoothServicesDevice* device,
                                              BluetoothServicesAdapter* adapter);
BluetoothDeviceRow* bluetooth_device_row_construct (GType object_type,
                                                    BluetoothServicesDevice* device,
                                                    BluetoothServicesAdapter* adapter);
static void bluetooth_device_row_button_clicked_data_free (gpointer _data);
static void bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                                 GAsyncResult* _res_);
static gboolean bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_);
BluetoothServicesDevice* bluetooth_device_row_get_device (BluetoothDeviceRow* self);
gboolean bluetooth_services_device_get_paired (BluetoothServicesDevice* self);
static void bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                      BluetoothDeviceRowStatus status);
void bluetooth_services_device_pair (BluetoothServicesDevice* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void bluetooth_services_device_pair_finish (BluetoothServicesDevice* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static void bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
gboolean bluetooth_services_device_get_connected (BluetoothServicesDevice* self);
void bluetooth_services_device_connect (BluetoothServicesDevice* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void bluetooth_services_device_connect_finish (BluetoothServicesDevice* self,
                                               GAsyncResult* _res_,
                                               GError** error);
void bluetooth_services_device_disconnect (BluetoothServicesDevice* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void bluetooth_services_device_disconnect_finish (BluetoothServicesDevice* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void bluetooth_device_row_compute_status (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                      BluetoothServicesDevice* value);
BluetoothServicesAdapter* bluetooth_device_row_get_adapter (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                       BluetoothServicesAdapter* value);
static GObject * bluetooth_device_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
gchar* bluetooth_services_device_get_icon (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_address (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_name (BluetoothServicesDevice* self);
gboolean bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self);
static void _bluetooth_device_row___lambda16_ (BluetoothDeviceRow* self,
                                        GVariant* changed,
                                        gchar** invalid,
                                        gint invalid_length1);
static void __bluetooth_device_row___lambda16__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda17_ (Block2Data* _data2_,
                                        GVariant* changed,
                                        gchar** invalid,
                                        gint invalid_length1);
static void __bluetooth_device_row___lambda17__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda18_ (BluetoothDeviceRow* self);
void bluetooth_services_device_set_trusted (BluetoothServicesDevice* self,
                                            gboolean value);
static void __bluetooth_device_row___lambda18__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void bluetooth_device_row_finalize (GObject * obj);
static GType bluetooth_device_row_get_type_once (void);
static void _vala_bluetooth_device_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_bluetooth_device_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static gint _vala_array_length (gpointer array);

static inline gpointer
bluetooth_device_row_get_instance_private (BluetoothDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothDeviceRow_private_offset);
}

static gchar*
bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self)
{
	gchar* result = NULL;
	switch (self) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Available"));
			result = _tmp0_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Pairing…"));
			result = _tmp1_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Connected"));
			result = _tmp2_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Connecting…"));
			result = _tmp3_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Disconnecting…"));
			result = _tmp4_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Unable to Connect"));
			result = _tmp5_;
			return result;
		}
		default:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Not Connected"));
			result = _tmp6_;
			return result;
		}
	}
}

static GType
bluetooth_device_row_status_get_type_once (void)
{
	static const GEnumValue values[] = {{BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED", "unpaired"}, {BLUETOOTH_DEVICE_ROW_STATUS_PAIRING, "BLUETOOTH_DEVICE_ROW_STATUS_PAIRING", "pairing"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED", "connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING", "connecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING", "disconnecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED", "not-connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT", "unable-to-connect"}, {0, NULL, NULL}};
	GType bluetooth_device_row_status_type_id;
	bluetooth_device_row_status_type_id = g_enum_register_static ("BluetoothDeviceRowStatus", values);
	return bluetooth_device_row_status_type_id;
}

static GType
bluetooth_device_row_status_get_type (void)
{
	static volatile gsize bluetooth_device_row_status_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_status_type_id__volatile)) {
		GType bluetooth_device_row_status_type_id;
		bluetooth_device_row_status_type_id = bluetooth_device_row_status_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_status_type_id__volatile, bluetooth_device_row_status_type_id);
	}
	return bluetooth_device_row_status_type_id__volatile;
}

BluetoothDeviceRow*
bluetooth_device_row_construct (GType object_type,
                                BluetoothServicesDevice* device,
                                BluetoothServicesAdapter* adapter)
{
	BluetoothDeviceRow * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (adapter != NULL, NULL);
	self = (BluetoothDeviceRow*) g_object_new (object_type, "device", device, "adapter", adapter, NULL);
	return self;
}

BluetoothDeviceRow*
bluetooth_device_row_new (BluetoothServicesDevice* device,
                          BluetoothServicesAdapter* adapter)
{
	return bluetooth_device_row_construct (BLUETOOTH_TYPE_DEVICE_ROW, device, adapter);
}

static void
bluetooth_device_row_button_clicked_data_free (gpointer _data)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (BluetoothDeviceRowButtonClickedData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	BluetoothDeviceRow* _tmp0_;
	_data_ = g_slice_new0 (BluetoothDeviceRowButtonClickedData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_device_row_button_clicked_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static void
bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                            GAsyncResult* _res_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static gboolean
bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_device;
	_data_->_tmp1_ = bluetooth_services_device_get_paired (_data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	if (!_data_->_tmp2_) {
		bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_PAIRING);
		{
			_data_->_tmp3_ = _data_->self->priv->_device;
			_data_->_state_ = 1;
			bluetooth_services_device_pair (_data_->_tmp3_, bluetooth_device_row_button_clicked_ready, _data_);
			return FALSE;
			_state_1:
			bluetooth_services_device_pair_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
			_data_->_tmp4_ = _data_->e;
			_data_->_tmp5_ = _data_->_tmp4_->message;
			g_critical ("DeviceRow.vala:186: %s", _data_->_tmp5_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->_tmp6_ = _data_->self->priv->_device;
		_data_->_tmp7_ = bluetooth_services_device_get_connected (_data_->_tmp6_);
		_data_->_tmp8_ = _data_->_tmp7_;
		if (!_data_->_tmp8_) {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING);
			{
				_data_->_tmp9_ = _data_->self->priv->_device;
				_data_->_state_ = 2;
				bluetooth_services_device_connect (_data_->_tmp9_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_2:
				bluetooth_services_device_connect_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				_data_->_vala1_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
				_data_->_tmp10_ = _data_->_vala1_e;
				_data_->_tmp11_ = _data_->_tmp10_->message;
				g_critical ("DeviceRow.vala:194: %s", _data_->_tmp11_);
				_g_error_free0 (_data_->_vala1_e);
			}
			__finally1:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		} else {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING);
			{
				_data_->_tmp12_ = _data_->self->priv->_device;
				_data_->_state_ = 3;
				bluetooth_services_device_disconnect (_data_->_tmp12_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_3:
				bluetooth_services_device_disconnect_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				_data_->_vala2_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				_data_->_tmp13_ = _data_->self->priv->state;
				g_object_set (_data_->_tmp13_, "icon-name", "user-busy", NULL);
				_data_->_tmp14_ = _data_->_vala2_e;
				_data_->_tmp15_ = _data_->_tmp14_->message;
				g_critical ("DeviceRow.vala:202: %s", _data_->_tmp15_);
				_g_error_free0 (_data_->_vala2_e);
			}
			__finally2:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
bluetooth_device_row_compute_status (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = bluetooth_services_device_get_paired (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED);
	} else {
		BluetoothServicesDevice* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->_device;
		_tmp4_ = bluetooth_services_device_get_connected (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
		} else {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
		}
	}
}

static void
bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                 BluetoothDeviceRowStatus status)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->state_label;
	_tmp1_ = bluetooth_device_row_status_to_string (status);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp2_);
	_tmp4_ = _tmp3_;
	gtk_label_set_label (_tmp0_, _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp5_ = self->priv->state;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, FALSE);
	_tmp6_ = self->priv->state;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	switch (status) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			GtkButton* _tmp7_;
			GtkButton* _tmp8_;
			GtkLinkButton* _tmp9_;
			GtkImage* _tmp10_;
			GtkImage* _tmp11_;
			_tmp7_ = self->priv->connect_button;
			gtk_button_set_label (_tmp7_, _ ("Pair"));
			_tmp8_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
			_tmp9_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
			_tmp10_ = self->priv->state;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
			_tmp11_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			GtkButton* _tmp12_;
			GtkImage* _tmp13_;
			GtkLinkButton* _tmp14_;
			_tmp12_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, FALSE);
			_tmp13_ = self->priv->state;
			g_object_set (_tmp13_, "icon-name", "user-away", NULL);
			_tmp14_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp14_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			GtkButton* _tmp15_;
			GtkButton* _tmp16_;
			GtkImage* _tmp17_;
			GtkLinkButton* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			_tmp15_ = self->priv->connect_button;
			gtk_button_set_label (_tmp15_, _ ("Disconnect"));
			_tmp16_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, TRUE);
			_tmp17_ = self->priv->state;
			g_object_set (_tmp17_, "icon-name", "user-available", NULL);
			_tmp18_ = self->priv->settings_button;
			_tmp19_ = gtk_link_button_get_uri (_tmp18_);
			_tmp20_ = _tmp19_;
			if (g_strcmp0 (_tmp20_, "") != 0) {
				GtkLinkButton* _tmp21_;
				_tmp21_ = self->priv->settings_button;
				gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
			}
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			GtkButton* _tmp22_;
			GtkImage* _tmp23_;
			GtkLinkButton* _tmp24_;
			_tmp22_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, FALSE);
			_tmp23_ = self->priv->state;
			g_object_set (_tmp23_, "icon-name", "user-away", NULL);
			_tmp24_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp24_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			GtkButton* _tmp25_;
			GtkImage* _tmp26_;
			GtkLinkButton* _tmp27_;
			_tmp25_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, FALSE);
			_tmp26_ = self->priv->state;
			g_object_set (_tmp26_, "icon-name", "user-away", NULL);
			_tmp27_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp27_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED:
		{
			GtkButton* _tmp28_;
			GtkButton* _tmp29_;
			GtkImage* _tmp30_;
			GtkLinkButton* _tmp31_;
			_tmp28_ = self->priv->connect_button;
			gtk_button_set_label (_tmp28_, _ ("Connect"));
			_tmp29_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp29_, TRUE);
			_tmp30_ = self->priv->state;
			g_object_set (_tmp30_, "icon-name", "user-offline", NULL);
			_tmp31_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		{
			GtkButton* _tmp32_;
			GtkImage* _tmp33_;
			GtkLinkButton* _tmp34_;
			_tmp32_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp32_, TRUE);
			_tmp33_ = self->priv->state;
			g_object_set (_tmp33_, "icon-name", "user-busy", NULL);
			_tmp34_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp34_, FALSE);
			break;
		}
		default:
		break;
	}
	g_signal_emit (self, bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL], 0);
}

BluetoothServicesDevice*
bluetooth_device_row_get_device (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* result;
	BluetoothServicesDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                 BluetoothServicesDevice* value)
{
	g_return_if_fail (self != NULL);
	if (bluetooth_device_row_get_device (self) != value) {
		BluetoothServicesDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY]);
	}
}

BluetoothServicesAdapter*
bluetooth_device_row_get_adapter (BluetoothDeviceRow* self)
{
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_adapter;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                  BluetoothServicesAdapter* value)
{
	g_return_if_fail (self != NULL);
	if (bluetooth_device_row_get_adapter (self) != value) {
		self->priv->_adapter = value;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY]);
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		BluetoothDeviceRow* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->label);
		_g_object_unref0 (_data2_->image);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
_bluetooth_device_row___lambda16_ (BluetoothDeviceRow* self,
                                   GVariant* changed,
                                   gchar** invalid,
                                   gint invalid_length1)
{
	GVariant* powered = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Powered", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	powered = _tmp3_;
	_tmp4_ = powered;
	if (_tmp4_ != NULL) {
		BluetoothServicesAdapter* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->_adapter;
		_tmp6_ = bluetooth_services_adapter_get_powered (_tmp5_);
		_tmp7_ = _tmp6_;
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp7_);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_g_variant_unref0 (powered);
}

static void
__bluetooth_device_row___lambda16__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda16_ ((BluetoothDeviceRow*) self, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
}

static void
_bluetooth_device_row___lambda17_ (Block2Data* _data2_,
                                   GVariant* changed,
                                   gchar** invalid,
                                   gint invalid_length1)
{
	BluetoothDeviceRow* self;
	GVariant* paired = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* connected = NULL;
	GVariantType* _tmp5_;
	GVariantType* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* name = NULL;
	GVariantType* _tmp10_;
	GVariantType* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* icon = NULL;
	GVariantType* _tmp20_;
	GVariantType* _tmp21_;
	GVariant* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	self = _data2_->self;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Paired", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	paired = _tmp3_;
	_tmp4_ = paired;
	if (_tmp4_ != NULL) {
		bluetooth_device_row_compute_status (self);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp5_ = g_variant_type_new ("b");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_variant_lookup_value (changed, "Connected", _tmp6_);
	_tmp8_ = _tmp7_;
	_g_variant_type_free0 (_tmp6_);
	connected = _tmp8_;
	_tmp9_ = connected;
	if (_tmp9_ != NULL) {
		bluetooth_device_row_compute_status (self);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp10_ = g_variant_type_new ("s");
	_tmp11_ = _tmp10_;
	_tmp12_ = g_variant_lookup_value (changed, "Name", _tmp11_);
	_tmp13_ = _tmp12_;
	_g_variant_type_free0 (_tmp11_);
	name = _tmp13_;
	_tmp14_ = name;
	if (_tmp14_ != NULL) {
		GtkLabel* _tmp15_;
		BluetoothServicesDevice* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp15_ = _data2_->label;
		_tmp16_ = self->priv->_device;
		_tmp17_ = bluetooth_services_device_get_name (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = _tmp18_;
		gtk_label_set_label (_tmp15_, _tmp19_);
		_g_free0 (_tmp19_);
	}
	_tmp20_ = g_variant_type_new ("s");
	_tmp21_ = _tmp20_;
	_tmp22_ = g_variant_lookup_value (changed, "Icon", _tmp21_);
	_tmp23_ = _tmp22_;
	_g_variant_type_free0 (_tmp21_);
	icon = _tmp23_;
	_tmp24_ = icon;
	if (_tmp24_ != NULL) {
		gchar* _tmp25_ = NULL;
		BluetoothServicesDevice* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		GtkImage* _tmp30_;
		_tmp26_ = self->priv->_device;
		_tmp27_ = bluetooth_services_device_get_icon (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp25_ = _tmp28_;
		if (_tmp25_ == NULL) {
			gchar* _tmp29_;
			_tmp29_ = g_strdup ("bluetooth");
			_g_free0 (_tmp25_);
			_tmp25_ = _tmp29_;
		}
		_tmp30_ = _data2_->image;
		g_object_set (_tmp30_, "icon-name", _tmp25_, NULL);
		_g_free0 (_tmp25_);
	}
	_g_variant_unref0 (icon);
	_g_variant_unref0 (name);
	_g_variant_unref0 (connected);
	_g_variant_unref0 (paired);
}

static void
__bluetooth_device_row___lambda17__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda17_ (self, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
}

static void
_bluetooth_device_row___lambda18_ (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	BluetoothServicesDevice* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	bluetooth_device_row_button_clicked (self, NULL, NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_paired (_tmp1_);
	_tmp3_ = _tmp2_;
	bluetooth_services_device_set_trusted (_tmp0_, _tmp3_);
}

static void
__bluetooth_device_row___lambda18__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_bluetooth_device_row___lambda18_ ((BluetoothDeviceRow*) self);
}

static GObject *
bluetooth_device_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothDeviceRow * self;
	Block2Data* _data2_;
	gchar* _tmp0_ = NULL;
	BluetoothServicesDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp12_;
	GtkOverlay* _tmp13_;
	BluetoothServicesDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* _tmp20_;
	GtkImage* _tmp21_;
	gchar* _tmp22_ = NULL;
	BluetoothServicesDevice* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLinkButton* _tmp33_;
	GtkLinkButton* _tmp34_;
	GtkLinkButton* _tmp35_;
	GtkImage* _tmp36_;
	GtkImage* _tmp37_;
	GtkLinkButton* _tmp38_;
	GtkLinkButton* _tmp39_;
	GtkLinkButton* _tmp40_;
	GtkLinkButton* _tmp41_;
	GtkLinkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	GtkSizeGroup* _tmp45_;
	GtkButton* _tmp46_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp47_;
	GtkGrid* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkOverlay* _tmp52_;
	GtkGrid* _tmp53_;
	GtkLabel* _tmp54_;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkLinkButton* _tmp58_;
	GtkGrid* _tmp59_;
	GtkButton* _tmp60_;
	GtkGrid* _tmp61_;
	BluetoothServicesDevice* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	GQuark _tmp67_ = 0U;
	static GQuark _tmp66_label0 = 0;
	static GQuark _tmp66_label1 = 0;
	static GQuark _tmp66_label2 = 0;
	static GQuark _tmp66_label3 = 0;
	static GQuark _tmp66_label4 = 0;
	BluetoothServicesAdapter* _tmp76_;
	gboolean _tmp77_;
	gboolean _tmp78_;
	BluetoothServicesAdapter* _tmp79_;
	BluetoothServicesDevice* _tmp80_;
	GtkButton* _tmp81_;
	parent_class = G_OBJECT_CLASS (bluetooth_device_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_icon (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("bluetooth");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp5_);
	_data2_->image = _tmp5_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->state);
	self->priv->state = _tmp6_;
	_tmp7_ = self->priv->state;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
	_tmp8_ = self->priv->state;
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->state_label);
	self->priv->state_label = _tmp9_;
	_tmp10_ = self->priv->state_label;
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
	_tmp11_ = self->priv->state_label;
	gtk_label_set_use_markup (_tmp11_, TRUE);
	_tmp12_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp12_);
	overlay = _tmp12_;
	_tmp13_ = overlay;
	_tmp14_ = self->priv->_device;
	_tmp15_ = bluetooth_services_device_get_address (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = _tmp16_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp17_);
	_g_free0 (_tmp17_);
	_tmp18_ = overlay;
	_tmp19_ = _data2_->image;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = overlay;
	_tmp21_ = self->priv->state;
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp23_ = self->priv->_device;
	_tmp24_ = bluetooth_services_device_get_name (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp22_ = _tmp25_;
	if (_tmp22_ == NULL) {
		BluetoothServicesDevice* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp26_ = self->priv->_device;
		_tmp27_ = bluetooth_services_device_get_address (_tmp26_);
		_tmp28_ = _tmp27_;
		_g_free0 (_tmp22_);
		_tmp22_ = _tmp28_;
	}
	_tmp29_ = (GtkLabel*) gtk_label_new (_tmp22_);
	g_object_ref_sink (_tmp29_);
	_data2_->label = _tmp29_;
	_tmp30_ = _data2_->label;
	gtk_label_set_ellipsize (_tmp30_, PANGO_ELLIPSIZE_END);
	_tmp31_ = _data2_->label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp31_, TRUE);
	_tmp32_ = _data2_->label;
	gtk_label_set_xalign (_tmp32_, (gfloat) 0);
	_tmp33_ = (GtkLinkButton*) gtk_link_button_new ("");
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->settings_button);
	self->priv->settings_button = _tmp33_;
	_tmp34_ = self->priv->settings_button;
	gtk_button_set_always_show_image ((GtkButton*) _tmp34_, TRUE);
	_tmp35_ = self->priv->settings_button;
	_tmp36_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp36_);
	_tmp37_ = _tmp36_;
	gtk_button_set_image ((GtkButton*) _tmp35_, (GtkWidget*) _tmp37_);
	_g_object_unref0 (_tmp37_);
	_tmp38_ = self->priv->settings_button;
	gtk_button_set_label ((GtkButton*) _tmp38_, NULL);
	_tmp39_ = self->priv->settings_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp39_, 3);
	_tmp40_ = self->priv->settings_button;
	gtk_widget_show_all ((GtkWidget*) _tmp40_);
	_tmp41_ = self->priv->settings_button;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp41_, TRUE);
	_tmp42_ = self->priv->settings_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp42_, FALSE);
	_tmp43_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp43_);
	_g_object_unref0 (self->priv->connect_button);
	self->priv->connect_button = _tmp43_;
	_tmp44_ = self->priv->connect_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp44_, GTK_ALIGN_CENTER);
	_tmp45_ = bluetooth_device_row_size_group;
	_tmp46_ = self->priv->connect_button;
	gtk_size_group_add_widget (_tmp45_, (GtkWidget*) _tmp46_);
	_tmp47_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp47_);
	grid = _tmp47_;
	_tmp48_ = grid;
	g_object_set ((GtkWidget*) _tmp48_, "margin", 6, NULL);
	_tmp49_ = grid;
	gtk_grid_set_column_spacing (_tmp49_, 6);
	_tmp50_ = grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp50_, GTK_ORIENTATION_HORIZONTAL);
	_tmp51_ = grid;
	_tmp52_ = overlay;
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 0, 0, 1, 2);
	_tmp53_ = grid;
	_tmp54_ = _data2_->label;
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 1, 0, 1, 1);
	_tmp55_ = grid;
	_tmp56_ = self->priv->state_label;
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 1, 1, 1, 1);
	_tmp57_ = grid;
	_tmp58_ = self->priv->settings_button;
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 2, 0, 1, 2);
	_tmp59_ = grid;
	_tmp60_ = self->priv->connect_button;
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 3, 0, 1, 2);
	_tmp61_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp61_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp62_ = self->priv->_device;
	_tmp63_ = bluetooth_services_device_get_icon (_tmp62_);
	_tmp64_ = _tmp63_;
	_tmp65_ = _tmp64_;
	_tmp67_ = (NULL == _tmp65_) ? 0 : g_quark_from_string (_tmp65_);
	g_free (_tmp65_);
	if (_tmp67_ == ((0 != _tmp66_label0) ? _tmp66_label0 : (_tmp66_label0 = g_quark_from_static_string ("audio-card")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp68_;
				GtkLinkButton* _tmp69_;
				_tmp68_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp68_, "settings://sound");
				_tmp69_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp69_, _ ("Sound Settings"));
				break;
			}
		}
	} else if ((_tmp67_ == ((0 != _tmp66_label1) ? _tmp66_label1 : (_tmp66_label1 = g_quark_from_static_string ("input-gaming")))) || (_tmp67_ == ((0 != _tmp66_label2) ? _tmp66_label2 : (_tmp66_label2 = g_quark_from_static_string ("input-keyboard"))))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp70_;
				GtkLinkButton* _tmp71_;
				_tmp70_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp70_, "settings://input/keyboard");
				_tmp71_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp71_, _ ("Keyboard Settings"));
				break;
			}
		}
	} else if (_tmp67_ == ((0 != _tmp66_label3) ? _tmp66_label3 : (_tmp66_label3 = g_quark_from_static_string ("input-mouse")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp72_;
				GtkLinkButton* _tmp73_;
				_tmp72_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp72_, "settings://input/mouse");
				_tmp73_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp73_, _ ("Mouse & Touchpad Settings"));
				break;
			}
		}
	} else if (_tmp67_ == ((0 != _tmp66_label4) ? _tmp66_label4 : (_tmp66_label4 = g_quark_from_static_string ("printer")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp74_;
				GtkLinkButton* _tmp75_;
				_tmp74_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp74_, "settings://printer");
				_tmp75_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp75_, _ ("Printer Settings"));
				break;
			}
		}
	}
	bluetooth_device_row_compute_status (self);
	_tmp76_ = self->priv->_adapter;
	_tmp77_ = bluetooth_services_adapter_get_powered (_tmp76_);
	_tmp78_ = _tmp77_;
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp78_);
	_tmp79_ = self->priv->_adapter;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_TYPE (_tmp79_, g_dbus_proxy_get_type ()) ? ((GDBusProxy*) _tmp79_) : NULL, "g-properties-changed", (GCallback) __bluetooth_device_row___lambda16__g_dbus_proxy_g_properties_changed, self, 0);
	_tmp80_ = self->priv->_device;
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_TYPE (_tmp80_, g_dbus_proxy_get_type ()) ? ((GDBusProxy*) _tmp80_) : NULL, "g-properties-changed", (GCallback) __bluetooth_device_row___lambda17__g_dbus_proxy_g_properties_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp81_ = self->priv->connect_button;
	g_signal_connect_object (_tmp81_, "clicked", (GCallback) __bluetooth_device_row___lambda18__gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_free0 (_tmp22_);
	_g_object_unref0 (overlay);
	_g_free0 (_tmp0_);
	return obj;
}

static void
bluetooth_device_row_class_init (BluetoothDeviceRowClass * klass,
                                 gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
	bluetooth_device_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BluetoothDeviceRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_device_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_device_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = bluetooth_device_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = bluetooth_device_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY] = g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL] = g_signal_new ("status-changed", BLUETOOTH_TYPE_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	_g_object_unref0 (bluetooth_device_row_size_group);
	bluetooth_device_row_size_group = _tmp0_;
}

static void
bluetooth_device_row_instance_init (BluetoothDeviceRow * self,
                                    gpointer klass)
{
	self->priv = bluetooth_device_row_get_instance_private (self);
}

static void
bluetooth_device_row_finalize (GObject * obj)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->connect_button);
	_g_object_unref0 (self->priv->state);
	_g_object_unref0 (self->priv->state_label);
	_g_object_unref0 (self->priv->settings_button);
	G_OBJECT_CLASS (bluetooth_device_row_parent_class)->finalize (obj);
}

static GType
bluetooth_device_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothDeviceRow), 0, (GInstanceInitFunc) bluetooth_device_row_instance_init, NULL };
	GType bluetooth_device_row_type_id;
	bluetooth_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothDeviceRow", &g_define_type_info, 0);
	BluetoothDeviceRow_private_offset = g_type_add_instance_private (bluetooth_device_row_type_id, sizeof (BluetoothDeviceRowPrivate));
	return bluetooth_device_row_type_id;
}

GType
bluetooth_device_row_get_type (void)
{
	static volatile gsize bluetooth_device_row_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_type_id__volatile)) {
		GType bluetooth_device_row_type_id;
		bluetooth_device_row_type_id = bluetooth_device_row_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_type_id__volatile, bluetooth_device_row_type_id);
	}
	return bluetooth_device_row_type_id__volatile;
}

static void
_vala_bluetooth_device_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_device (self));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_adapter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bluetooth_device_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		bluetooth_device_row_set_device (self, g_value_get_object (value));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		bluetooth_device_row_set_adapter (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

