/* Agent.c generated by valac 0.47.92, the Vala compiler
 * generated from Agent.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gtk/gtk.h>

#define BLUETOOTH_SERVICES_TYPE_AGENT (bluetooth_services_agent_get_type ())
#define BLUETOOTH_SERVICES_AGENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_AGENT, BluetoothServicesAgent))
#define BLUETOOTH_SERVICES_AGENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_SERVICES_TYPE_AGENT, BluetoothServicesAgentClass))
#define BLUETOOTH_SERVICES_IS_AGENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_AGENT))
#define BLUETOOTH_SERVICES_IS_AGENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_SERVICES_TYPE_AGENT))
#define BLUETOOTH_SERVICES_AGENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_SERVICES_TYPE_AGENT, BluetoothServicesAgentClass))

typedef struct _BluetoothServicesAgent BluetoothServicesAgent;
typedef struct _BluetoothServicesAgentClass BluetoothServicesAgentClass;
typedef struct _BluetoothServicesAgentPrivate BluetoothServicesAgentPrivate;
enum  {
	BLUETOOTH_SERVICES_AGENT_0_PROPERTY,
	BLUETOOTH_SERVICES_AGENT_READY_PROPERTY,
	BLUETOOTH_SERVICES_AGENT_NUM_PROPERTIES
};
static GParamSpec* bluetooth_services_agent_properties[BLUETOOTH_SERVICES_AGENT_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_PAIR_DIALOG (pair_dialog_get_type ())
#define PAIR_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAIR_DIALOG, PairDialog))
#define PAIR_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAIR_DIALOG, PairDialogClass))
#define IS_PAIR_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAIR_DIALOG))
#define IS_PAIR_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAIR_DIALOG))
#define PAIR_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAIR_DIALOG, PairDialogClass))

typedef struct _PairDialog PairDialog;
typedef struct _PairDialogClass PairDialogClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	BLUETOOTH_SERVICES_AGENT_UNREGISTERED_SIGNAL,
	BLUETOOTH_SERVICES_AGENT_NUM_SIGNALS
};
static guint bluetooth_services_agent_signals[BLUETOOTH_SERVICES_AGENT_NUM_SIGNALS] = {0};
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	BLUEZ_ERROR_REJECTED,
	BLUEZ_ERROR_CANCELED
} BluezError;
#define BLUEZ_ERROR bluez_error_quark ()
struct _BluetoothServicesAgent {
	GObject parent_instance;
	BluetoothServicesAgentPrivate * priv;
};

struct _BluetoothServicesAgentClass {
	GObjectClass parent_class;
};

struct _BluetoothServicesAgentPrivate {
	gboolean _ready;
};

static gint BluetoothServicesAgent_private_offset;
static gpointer bluetooth_services_agent_parent_class = NULL;

GQuark bluez_error_quark (void);
GType bluetooth_services_agent_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BluetoothServicesAgent, g_object_unref)
guint bluetooth_services_agent_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
#define BLUETOOTH_SERVICES_AGENT_PATH "/org/bluez/agent/elementary"
BluetoothServicesAgent* bluetooth_services_agent_new (void);
BluetoothServicesAgent* bluetooth_services_agent_construct (GType object_type);
static void __lambda6_ (BluetoothServicesAgent* self,
                 GDBusConnection* connection,
                 const gchar* name);
static void bluetooth_services_agent_set_ready (BluetoothServicesAgent* self,
                                         gboolean value);
static void ___lambda6__gbus_acquired_callback (GDBusConnection* connection,
                                         const gchar* name,
                                         gpointer self);
static void __lambda7_ (BluetoothServicesAgent* self,
                 GDBusConnection* connection,
                 const gchar* name);
static void ___lambda7__gbus_name_acquired_callback (GDBusConnection* connection,
                                              const gchar* name,
                                              gpointer self);
static void __lambda8_ (BluetoothServicesAgent* self,
                 GDBusConnection* connection,
                 const gchar* name);
static void ___lambda8__gbus_name_lost_callback (GDBusConnection* connection,
                                          const gchar* name,
                                          gpointer self);
char* bluetooth_services_agent_get_path (BluetoothServicesAgent* self);
void bluetooth_services_agent_release (BluetoothServicesAgent* self,
                                       GError** error);
gchar* bluetooth_services_agent_request_pin_code (BluetoothServicesAgent* self,
                                                  const char* device,
                                                  GError** error);
void bluetooth_services_agent_display_pin_code (BluetoothServicesAgent* self,
                                                const char* device,
                                                const gchar* pincode,
                                                GError** error);
GType pair_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PairDialog, g_object_unref)
PairDialog* pair_dialog_new_with_pin_code (const char* object_path,
                                           const gchar* pincode);
PairDialog* pair_dialog_construct_with_pin_code (GType object_type,
                                                 const char* object_path,
                                                 const gchar* pincode);
guint32 bluetooth_services_agent_request_passkey (BluetoothServicesAgent* self,
                                                  const char* device,
                                                  GError** error);
void bluetooth_services_agent_display_passkey (BluetoothServicesAgent* self,
                                               const char* device,
                                               guint32 passkey,
                                               guint16 entered,
                                               GError** error);
PairDialog* pair_dialog_new_display_passkey (const char* object_path,
                                             guint32 passkey,
                                             guint16 entered);
PairDialog* pair_dialog_construct_display_passkey (GType object_type,
                                                   const char* object_path,
                                                   guint32 passkey,
                                                   guint16 entered);
void bluetooth_services_agent_request_confirmation (BluetoothServicesAgent* self,
                                                    const char* device,
                                                    guint32 passkey,
                                                    GError** error);
PairDialog* pair_dialog_new_request_confirmation (const char* object_path,
                                                  guint32 passkey);
PairDialog* pair_dialog_construct_request_confirmation (GType object_type,
                                                        const char* object_path,
                                                        guint32 passkey);
void bluetooth_services_agent_request_authorization (BluetoothServicesAgent* self,
                                                     const char* device,
                                                     GError** error);
PairDialog* pair_dialog_new (const char* object_path);
PairDialog* pair_dialog_construct (GType object_type,
                                   const char* object_path);
void bluetooth_services_agent_authorize_service (BluetoothServicesAgent* self,
                                                 const char* device,
                                                 const gchar* uuid,
                                                 GError** error);
void bluetooth_services_agent_cancel (BluetoothServicesAgent* self,
                                      GError** error);
gboolean bluetooth_services_agent_get_ready (BluetoothServicesAgent* self);
static void bluetooth_services_agent_finalize (GObject * obj);
static GType bluetooth_services_agent_get_type_once (void);
static void _vala_bluetooth_services_agent_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_bluetooth_services_agent_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _dbus_bluetooth_services_agent_release (BluetoothServicesAgent* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_request_pin_code (BluetoothServicesAgent* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_display_pin_code (BluetoothServicesAgent* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_request_passkey (BluetoothServicesAgent* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_display_passkey (BluetoothServicesAgent* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_request_confirmation (BluetoothServicesAgent* self,
                                                          GVariant* _parameters_,
                                                          GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_request_authorization (BluetoothServicesAgent* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_authorize_service (BluetoothServicesAgent* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_cancel (BluetoothServicesAgent* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void bluetooth_services_agent_dbus_interface_method_call (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* method_name,
                                                          GVariant* parameters,
                                                          GDBusMethodInvocation* invocation,
                                                          gpointer user_data);
static GVariant* bluetooth_services_agent_dbus_interface_get_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GError** error,
                                                                gpointer user_data);
static gboolean bluetooth_services_agent_dbus_interface_set_property (GDBusConnection* connection,
                                                               const gchar* sender,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* property_name,
                                                               GVariant* value,
                                                               GError** error,
                                                               gpointer user_data);
static void _bluetooth_services_agent_unregister_object (gpointer user_data);

static const GDBusErrorEntry bluez_error_entries[] = {{BLUEZ_ERROR_REJECTED, "org.bluez.Error.Rejected"}, {BLUEZ_ERROR_CANCELED, "org.bluez.Error.Canceled"}};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_release_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_release_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_release = {-1, "Release", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_release_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_release_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_request_pin_code_device = {-1, "device", "o", NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_request_pin_code_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_pin_code_in[] = {&_bluetooth_services_agent_dbus_arg_info_request_pin_code_device, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_pin_code_out[] = {&_bluetooth_services_agent_dbus_arg_info_request_pin_code_result, NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_request_pin_code = {-1, "RequestPinCode", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_pin_code_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_pin_code_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_display_pin_code_device = {-1, "device", "o", NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_display_pin_code_pincode = {-1, "pincode", "s", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_display_pin_code_in[] = {&_bluetooth_services_agent_dbus_arg_info_display_pin_code_device, &_bluetooth_services_agent_dbus_arg_info_display_pin_code_pincode, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_display_pin_code_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_display_pin_code = {-1, "DisplayPinCode", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_display_pin_code_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_display_pin_code_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_request_passkey_device = {-1, "device", "o", NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_request_passkey_result = {-1, "result", "u", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_passkey_in[] = {&_bluetooth_services_agent_dbus_arg_info_request_passkey_device, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_passkey_out[] = {&_bluetooth_services_agent_dbus_arg_info_request_passkey_result, NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_request_passkey = {-1, "RequestPasskey", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_passkey_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_passkey_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_display_passkey_device = {-1, "device", "o", NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_display_passkey_passkey = {-1, "passkey", "u", NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_display_passkey_entered = {-1, "entered", "q", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_display_passkey_in[] = {&_bluetooth_services_agent_dbus_arg_info_display_passkey_device, &_bluetooth_services_agent_dbus_arg_info_display_passkey_passkey, &_bluetooth_services_agent_dbus_arg_info_display_passkey_entered, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_display_passkey_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_display_passkey = {-1, "DisplayPasskey", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_display_passkey_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_display_passkey_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_request_confirmation_device = {-1, "device", "o", NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_request_confirmation_passkey = {-1, "passkey", "u", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_confirmation_in[] = {&_bluetooth_services_agent_dbus_arg_info_request_confirmation_device, &_bluetooth_services_agent_dbus_arg_info_request_confirmation_passkey, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_confirmation_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_request_confirmation = {-1, "RequestConfirmation", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_confirmation_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_confirmation_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_request_authorization_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_authorization_in[] = {&_bluetooth_services_agent_dbus_arg_info_request_authorization_device, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_request_authorization_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_request_authorization = {-1, "RequestAuthorization", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_authorization_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_request_authorization_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_authorize_service_device = {-1, "device", "o", NULL};
static const GDBusArgInfo _bluetooth_services_agent_dbus_arg_info_authorize_service_uuid = {-1, "uuid", "s", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_authorize_service_in[] = {&_bluetooth_services_agent_dbus_arg_info_authorize_service_device, &_bluetooth_services_agent_dbus_arg_info_authorize_service_uuid, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_authorize_service_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_authorize_service = {-1, "AuthorizeService", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_authorize_service_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_authorize_service_out), NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_cancel_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_dbus_arg_info_cancel_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_dbus_method_info_cancel = {-1, "Cancel", (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_cancel_in), (GDBusArgInfo **) (&_bluetooth_services_agent_dbus_arg_info_cancel_out), NULL};
static const GDBusMethodInfo * const _bluetooth_services_agent_dbus_method_info[] = {&_bluetooth_services_agent_dbus_method_info_release, &_bluetooth_services_agent_dbus_method_info_request_pin_code, &_bluetooth_services_agent_dbus_method_info_display_pin_code, &_bluetooth_services_agent_dbus_method_info_request_passkey, &_bluetooth_services_agent_dbus_method_info_display_passkey, &_bluetooth_services_agent_dbus_method_info_request_confirmation, &_bluetooth_services_agent_dbus_method_info_request_authorization, &_bluetooth_services_agent_dbus_method_info_authorize_service, &_bluetooth_services_agent_dbus_method_info_cancel, NULL};
static const GDBusSignalInfo * const _bluetooth_services_agent_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _bluetooth_services_agent_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _bluetooth_services_agent_dbus_interface_info = {-1, "org.bluez.Agent1", (GDBusMethodInfo **) (&_bluetooth_services_agent_dbus_method_info), (GDBusSignalInfo **) (&_bluetooth_services_agent_dbus_signal_info), (GDBusPropertyInfo **) (&_bluetooth_services_agent_dbus_property_info), NULL};
static const GDBusInterfaceVTable _bluetooth_services_agent_dbus_interface_vtable = {bluetooth_services_agent_dbus_interface_method_call, bluetooth_services_agent_dbus_interface_get_property, bluetooth_services_agent_dbus_interface_set_property};

GQuark
bluez_error_quark (void)
{
	static volatile gsize bluez_error_quark_volatile = 0;
	g_dbus_error_register_error_domain ("bluez-error-quark", &bluez_error_quark_volatile, bluez_error_entries, G_N_ELEMENTS (bluez_error_entries));
	return (GQuark) bluez_error_quark_volatile;
}

static inline gpointer
bluetooth_services_agent_get_instance_private (BluetoothServicesAgent* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothServicesAgent_private_offset);
}

static void
__lambda6_ (BluetoothServicesAgent* self,
            GDBusConnection* connection,
            const gchar* name)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
	{
		bluetooth_services_agent_register_object (self, connection, BLUETOOTH_SERVICES_AGENT_PATH, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		bluetooth_services_agent_set_ready (self, TRUE);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_critical ("Agent.vala:38: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda6__gbus_acquired_callback (GDBusConnection* connection,
                                    const gchar* name,
                                    gpointer self)
{
	__lambda6_ ((BluetoothServicesAgent*) self, connection, name);
}

static void
__lambda7_ (BluetoothServicesAgent* self,
            GDBusConnection* connection,
            const gchar* name)
{
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
}

static void
___lambda7__gbus_name_acquired_callback (GDBusConnection* connection,
                                         const gchar* name,
                                         gpointer self)
{
	__lambda7_ ((BluetoothServicesAgent*) self, connection, name);
}

static void
__lambda8_ (BluetoothServicesAgent* self,
            GDBusConnection* connection,
            const gchar* name)
{
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
}

static void
___lambda8__gbus_name_lost_callback (GDBusConnection* connection,
                                     const gchar* name,
                                     gpointer self)
{
	__lambda8_ ((BluetoothServicesAgent*) self, connection, name);
}

BluetoothServicesAgent*
bluetooth_services_agent_construct (GType object_type)
{
	BluetoothServicesAgent * self = NULL;
	self = (BluetoothServicesAgent*) g_object_new (object_type, NULL);
	g_bus_own_name_with_closures (G_BUS_TYPE_SYSTEM, "org.bluez.AgentManager1", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((___lambda6__gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda6__gbus_acquired_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((___lambda7__gbus_name_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda7__gbus_name_acquired_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((___lambda8__gbus_name_lost_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda8__gbus_name_lost_callback, g_object_ref (self), (GClosureNotify) g_object_unref)));
	return self;
}

BluetoothServicesAgent*
bluetooth_services_agent_new (void)
{
	return bluetooth_services_agent_construct (BLUETOOTH_SERVICES_TYPE_AGENT);
}

char*
bluetooth_services_agent_get_path (BluetoothServicesAgent* self)
{
	char* _tmp0_;
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (BLUETOOTH_SERVICES_AGENT_PATH);
	result = _tmp0_;
	return result;
}

void
bluetooth_services_agent_release (BluetoothServicesAgent* self,
                                  GError** error)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, bluetooth_services_agent_signals[BLUETOOTH_SERVICES_AGENT_UNREGISTERED_SIGNAL], 0);
}

gchar*
bluetooth_services_agent_request_pin_code (BluetoothServicesAgent* self,
                                           const char* device,
                                           GError** error)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (device != NULL, NULL);
	_tmp0_ = g_strdup ("");
	result = _tmp0_;
	return result;
}

void
bluetooth_services_agent_display_pin_code (BluetoothServicesAgent* self,
                                           const char* device,
                                           const gchar* pincode,
                                           GError** error)
{
	PairDialog* pair_dialog = NULL;
	PairDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	g_return_if_fail (pincode != NULL);
	_tmp0_ = pair_dialog_new_with_pin_code (device, pincode);
	g_object_ref_sink (_tmp0_);
	pair_dialog = _tmp0_;
	gtk_window_present ((GtkWindow*) pair_dialog);
	_g_object_unref0 (pair_dialog);
}

guint32
bluetooth_services_agent_request_passkey (BluetoothServicesAgent* self,
                                          const char* device,
                                          GError** error)
{
	guint32 result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (device != NULL, 0U);
	result = (guint32) 0;
	return result;
}

void
bluetooth_services_agent_display_passkey (BluetoothServicesAgent* self,
                                          const char* device,
                                          guint32 passkey,
                                          guint16 entered,
                                          GError** error)
{
	PairDialog* pair_dialog = NULL;
	PairDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = pair_dialog_new_display_passkey (device, passkey, entered);
	g_object_ref_sink (_tmp0_);
	pair_dialog = _tmp0_;
	gtk_window_present ((GtkWindow*) pair_dialog);
	_g_object_unref0 (pair_dialog);
}

void
bluetooth_services_agent_request_confirmation (BluetoothServicesAgent* self,
                                               const char* device,
                                               guint32 passkey,
                                               GError** error)
{
	PairDialog* pair_dialog = NULL;
	PairDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = pair_dialog_new_request_confirmation (device, passkey);
	g_object_ref_sink (_tmp0_);
	pair_dialog = _tmp0_;
	gtk_window_present ((GtkWindow*) pair_dialog);
	_g_object_unref0 (pair_dialog);
}

void
bluetooth_services_agent_request_authorization (BluetoothServicesAgent* self,
                                                const char* device,
                                                GError** error)
{
	PairDialog* pair_dialog = NULL;
	PairDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = pair_dialog_new (device);
	g_object_ref_sink (_tmp0_);
	pair_dialog = _tmp0_;
	gtk_window_present ((GtkWindow*) pair_dialog);
	_g_object_unref0 (pair_dialog);
}

void
bluetooth_services_agent_authorize_service (BluetoothServicesAgent* self,
                                            const char* device,
                                            const gchar* uuid,
                                            GError** error)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	g_return_if_fail (uuid != NULL);
}

void
bluetooth_services_agent_cancel (BluetoothServicesAgent* self,
                                 GError** error)
{
	g_return_if_fail (self != NULL);
}

gboolean
bluetooth_services_agent_get_ready (BluetoothServicesAgent* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_ready;
	return result;
}

static void
bluetooth_services_agent_set_ready (BluetoothServicesAgent* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (bluetooth_services_agent_get_ready (self) != value) {
		self->priv->_ready = value;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_services_agent_properties[BLUETOOTH_SERVICES_AGENT_READY_PROPERTY]);
	}
}

static void
bluetooth_services_agent_class_init (BluetoothServicesAgentClass * klass,
                                     gpointer klass_data)
{
	bluetooth_services_agent_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BluetoothServicesAgent_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_services_agent_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_services_agent_set_property;
	G_OBJECT_CLASS (klass)->finalize = bluetooth_services_agent_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_SERVICES_AGENT_READY_PROPERTY, bluetooth_services_agent_properties[BLUETOOTH_SERVICES_AGENT_READY_PROPERTY] = g_param_spec_boolean ("ready", "ready", "ready", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	bluetooth_services_agent_signals[BLUETOOTH_SERVICES_AGENT_UNREGISTERED_SIGNAL] = g_signal_new ("unregistered", BLUETOOTH_SERVICES_TYPE_AGENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
bluetooth_services_agent_instance_init (BluetoothServicesAgent * self,
                                        gpointer klass)
{
	self->priv = bluetooth_services_agent_get_instance_private (self);
}

static void
bluetooth_services_agent_finalize (GObject * obj)
{
	BluetoothServicesAgent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_SERVICES_TYPE_AGENT, BluetoothServicesAgent);
	G_OBJECT_CLASS (bluetooth_services_agent_parent_class)->finalize (obj);
}

static GType
bluetooth_services_agent_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothServicesAgentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_services_agent_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothServicesAgent), 0, (GInstanceInitFunc) bluetooth_services_agent_instance_init, NULL };
	GType bluetooth_services_agent_type_id;
	bluetooth_services_agent_type_id = g_type_register_static (G_TYPE_OBJECT, "BluetoothServicesAgent", &g_define_type_info, 0);
	g_type_set_qdata (bluetooth_services_agent_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) bluetooth_services_agent_register_object);
	BluetoothServicesAgent_private_offset = g_type_add_instance_private (bluetooth_services_agent_type_id, sizeof (BluetoothServicesAgentPrivate));
	return bluetooth_services_agent_type_id;
}

GType
bluetooth_services_agent_get_type (void)
{
	static volatile gsize bluetooth_services_agent_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_services_agent_type_id__volatile)) {
		GType bluetooth_services_agent_type_id;
		bluetooth_services_agent_type_id = bluetooth_services_agent_get_type_once ();
		g_once_init_leave (&bluetooth_services_agent_type_id__volatile, bluetooth_services_agent_type_id);
	}
	return bluetooth_services_agent_type_id__volatile;
}

static void
_vala_bluetooth_services_agent_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	BluetoothServicesAgent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_SERVICES_TYPE_AGENT, BluetoothServicesAgent);
	switch (property_id) {
		case BLUETOOTH_SERVICES_AGENT_READY_PROPERTY:
		g_value_set_boolean (value, bluetooth_services_agent_get_ready (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bluetooth_services_agent_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	BluetoothServicesAgent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_SERVICES_TYPE_AGENT, BluetoothServicesAgent);
	switch (property_id) {
		case BLUETOOTH_SERVICES_AGENT_READY_PROPERTY:
		bluetooth_services_agent_set_ready (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_dbus_bluetooth_services_agent_release (BluetoothServicesAgent* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	bluetooth_services_agent_release (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_bluetooth_services_agent_request_pin_code (BluetoothServicesAgent* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp0_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	result = bluetooth_services_agent_request_pin_code (self, device, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
}

static void
_dbus_bluetooth_services_agent_display_pin_code (BluetoothServicesAgent* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp1_;
	gchar* pincode = NULL;
	GVariant* _tmp2_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	pincode = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	bluetooth_services_agent_display_pin_code (self, device, pincode, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
	_g_free0 (pincode);
}

static void
_dbus_bluetooth_services_agent_request_passkey (BluetoothServicesAgent* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp3_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	result = bluetooth_services_agent_request_passkey (self, device, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
}

static void
_dbus_bluetooth_services_agent_display_passkey (BluetoothServicesAgent* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp4_;
	guint32 passkey = 0U;
	GVariant* _tmp5_;
	guint16 entered = 0U;
	GVariant* _tmp6_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	passkey = g_variant_get_uint32 (_tmp5_);
	g_variant_unref (_tmp5_);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	entered = g_variant_get_uint16 (_tmp6_);
	g_variant_unref (_tmp6_);
	bluetooth_services_agent_display_passkey (self, device, passkey, entered, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
}

static void
_dbus_bluetooth_services_agent_request_confirmation (BluetoothServicesAgent* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp7_;
	guint32 passkey = 0U;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	passkey = g_variant_get_uint32 (_tmp8_);
	g_variant_unref (_tmp8_);
	bluetooth_services_agent_request_confirmation (self, device, passkey, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
}

static void
_dbus_bluetooth_services_agent_request_authorization (BluetoothServicesAgent* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp9_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	bluetooth_services_agent_request_authorization (self, device, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
}

static void
_dbus_bluetooth_services_agent_authorize_service (BluetoothServicesAgent* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp10_;
	gchar* uuid = NULL;
	GVariant* _tmp11_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp10_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	uuid = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	bluetooth_services_agent_authorize_service (self, device, uuid, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
	_g_free0 (uuid);
}

static void
_dbus_bluetooth_services_agent_cancel (BluetoothServicesAgent* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	bluetooth_services_agent_cancel (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
bluetooth_services_agent_dbus_interface_method_call (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* method_name,
                                                     GVariant* parameters,
                                                     GDBusMethodInvocation* invocation,
                                                     gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Release") == 0) {
		_dbus_bluetooth_services_agent_release (object, parameters, invocation);
	} else if (strcmp (method_name, "RequestPinCode") == 0) {
		_dbus_bluetooth_services_agent_request_pin_code (object, parameters, invocation);
	} else if (strcmp (method_name, "DisplayPinCode") == 0) {
		_dbus_bluetooth_services_agent_display_pin_code (object, parameters, invocation);
	} else if (strcmp (method_name, "RequestPasskey") == 0) {
		_dbus_bluetooth_services_agent_request_passkey (object, parameters, invocation);
	} else if (strcmp (method_name, "DisplayPasskey") == 0) {
		_dbus_bluetooth_services_agent_display_passkey (object, parameters, invocation);
	} else if (strcmp (method_name, "RequestConfirmation") == 0) {
		_dbus_bluetooth_services_agent_request_confirmation (object, parameters, invocation);
	} else if (strcmp (method_name, "RequestAuthorization") == 0) {
		_dbus_bluetooth_services_agent_request_authorization (object, parameters, invocation);
	} else if (strcmp (method_name, "AuthorizeService") == 0) {
		_dbus_bluetooth_services_agent_authorize_service (object, parameters, invocation);
	} else if (strcmp (method_name, "Cancel") == 0) {
		_dbus_bluetooth_services_agent_cancel (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
bluetooth_services_agent_dbus_interface_get_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GError** error,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
bluetooth_services_agent_dbus_interface_set_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GVariant* value,
                                                      GError** error,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
bluetooth_services_agent_register_object (gpointer object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_bluetooth_services_agent_dbus_interface_info), &_bluetooth_services_agent_dbus_interface_vtable, data, _bluetooth_services_agent_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_bluetooth_services_agent_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

